package com.jclark.xsl;

class AttributePattern extends QualifiedPattern {
  private Name name;

  AttributePattern(Name name, Qualifier qualifier) {
    super(qualifier);
    this.name = name;
  }

  public boolean matches(ProcessContext context, Node node, int maxAncestors) {
    return node.getType() == Node.ATTRIBUTE && node.getName().equals(name) && super.matches(context, node, maxAncestors);
  }

  public Name getMatchName() {
    return name;
  }

  public byte getMatchNodeType() {
    return Node.ATTRIBUTE;
  }

  public NodeIterator select(ProcessContext context, Node node) {
    return new SingleNodeIterator(node.getAttribute(name));
  }
  
  public SubQuery createUnion(SubQuery query) {
    return null;
  }

  public int getSpecificity() {
    return 1 + super.getSpecificity();
  }
}
