package com.jclark.xsl;

class AttributeQualifier extends Qualifier {
  private Name name;
  private String value;

  AttributeQualifier(Name name, String value, Qualifier next) throws XSLException {
    super(next);
    this.name = name;
    this.value = value;
  }

  boolean matches(ProcessContext context, Node node, int maxAncestors) {
    String s = node.getAttributeValue(name);
    if (s == null)
      return false;
    return value == null || value.equals(s);
  }
}
