package com.jclark.xsl;

class ChildQualifier extends Qualifier {
  private Name elementTypeName;

  ChildQualifier(Name elementTypeName, Qualifier next) {
    super(next);
    this.elementTypeName = elementTypeName;
  }

  boolean matches(ProcessContext context, Node node, int maxAncestors) {
    for (NodeIterator iter = node.getChildren(true);;) {
      node = iter.next();
      if (node == null)
	break;
      if (node.getName().equals(elementTypeName))
	return true;
    }
    return false;
  }

}
