package com.jclark.xsl;

import java.util.Vector;

class MacroArgumentList implements AttributeListTemplate {
  private Vector args = new Vector();

  static
  class AttributeListImpl implements AttributeList {
    private Vector args;
    AttributeListImpl(Vector args) {
      this.args = args;
    }

    public int getAttributeCount() {
      return args.size()/2;
    }

    public Name getAttributeName(int i) {
      return (Name)args.elementAt(i * 2);
    }

    public int getAttributeIndex(Name name) {
      for (int i = 0; i < args.size(); i += 2)
	if (name.equals(args.elementAt(i)))
	  return i/2;
      return -1;
    }

    public String getAttributeValue(Name name) {
      for (int i = 0; i < args.size(); i += 2)
	if (name.equals(args.elementAt(i)))
	  return (String)args.elementAt(i + 1);
      return null;
    }

    public String getAttributeValue(int i) {
      return (String)args.elementAt(i * 2 + 1);
    }
  }

  public
  AttributeList instantiate(ProcessContext context, Node sourceNode) throws XSLException {
    Vector v = (Vector)args.clone();
    for (int i = 1; i < args.size(); i += 2)
      v.setElementAt(((Expression)v.elementAt(i)).eval(context, sourceNode), i);
    return new AttributeListImpl(v);
  }

  void add(Name name, String value, Node node) throws XSLException {
    args.addElement(name);
    args.addElement(PatternParser.createAttributeValueTemplate(node, value));
  }
}
