package com.jclark.xsl;

class ParentQualifier extends Qualifier {
  private Matcher pattern;

  ParentQualifier(Matcher pattern, Qualifier next) {
    super(next);
    this.pattern = pattern;
  }

  boolean matches(ProcessContext context, Node node, int maxAncestors) {
    if (maxAncestors == 0)
      return false;
    node = node.getParent();
    if (node == null)
      return false;
    return pattern.matches(context, node, maxAncestors - 1);
  }

  int getSpecificity() {
    return pattern.getSpecificity();
  }

}
