package com.jclark.xsl;

import java.util.Enumeration;
import java.util.Vector;

class TemplateRuleSet extends RuleSet {
  private static
  class TemplateRule extends Rule {
    final Action action;
    TemplateRule(Matcher matcher, int priority, Action action) {
      super(matcher, priority);
      this.action = action;
    }
  }

  void add(Enumeration patterns, int priority, Action action) {
    while (patterns.hasMoreElements())
      add((Matcher)patterns.nextElement(), priority, action);
  }

  void add(Matcher pattern, int priority, Action action) {
    super.add(new TemplateRule(pattern, priority, action));
  }

  Action getAction(ProcessContext context, Node node) throws XSLException {
    for (Enumeration enum = potentialRules(node); enum.hasMoreElements();) {
      TemplateRule rule = (TemplateRule)enum.nextElement();
      if (rule.matcher.matches(context, node))
	return rule.action;
    }
    return null;
  }

}
